Description

Puppetclass.search_for shows up in puppetclasses_controller and its respective method of the API. It uses scoped_search to look

for all puppetclasses that a host contains. Unfortunately, in the event of a lookup of a host that either belongs to no hostgroup or a

host that doesn't exist, this will return all puppetclasses.

This fix checks for this conditions and avoids returning all puppetclasses.

curl -v -k -H d"Content-Type:application/json" https://foreman/api/hosts/nonexistenthost/puppetclasses returns

Puppetclass.all without this fix,

after this fix it returns {} (no puppet classes, which is correct)

Associated revisions

Revision 7507fbce - 05/23/2013 08:13 AM - Daniel Lobato Garcia

fixes #2550 Puppetclass search_by_host doesn't return all classes for an unknown host

Tests for puppetclass API searches on nonexistent hosts

Puppetclass search_by_host does not fail if Host does not belong to any Hostgroup

Puppetclass search_by_host query looks for distinct puppetclasses instead of pruning them afterwards

Puppetclass pluck uses DISTINCT instead of .uniq on the result

Revision ce897ade - 05/28/2013 12:05 PM - Daniel Lobato Garcia

fixes #2550 Puppetclass search_by_host doesn't return all classes for an unknown host

Tests for puppetclass API searches on nonexistent hosts

Puppetclass search_by_host does not fail if Host does not belong to any Hostgroup

Puppetclass search_by_host query looks for distinct puppetclasses instead of pruning them afterwards

Puppetclass pluck uses DISTINCT instead of .uniq on the result

(cherry picked from commit 7507fbcede129c219ca1d85e757d2bdd17d5ffb9)

History

#1 - 05/23/2013 08:14 AM - Ohad Levy

- Category set to Search

- Target version set to 1.2.0

#2 - 05/23/2013 08:17 AM - Daniel Lobato Garcia

- Status changed from New to Closed

Applied in changeset 7507fbcede129c219ca1d85e757d2bdd17d5ffb9.
